#include <windows.h>

#if defined(_WIN32_WCE)
    #include <aygshell.h>
#endif

#include "pockethal.h"

using namespace PHAL;


#include "image.h"


TCHAR *lpszClassName = _T("PHal");
TCHAR *lpszCaption = _T("RotoZoom");


WNDCLASS wc;
MSG msg;


Display *display;


bool quit = false;


LRESULT CALLBACK WindowProc(HWND hWnd, unsigned uMsg, WPARAM wParam, LPARAM lParam) {


    switch (uMsg) {

        case WM_LBUTTONDOWN: 
        case WM_KEYDOWN:
            quit = true;
          return 0;
        

        case WM_CLOSE:
            PostQuitMessage(0);
          return 0;
    }

    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPTSTR pCmdLine, int nCmdShow)
{
  
  wc.style          = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc    = WindowProc;
  wc.cbClsExtra     = 0;
  wc.cbWndExtra     = sizeof(DWORD);
  wc.hInstance      = hInstance;
  wc.hIcon          = NULL;
  wc.hCursor        = NULL;
  wc.hbrBackground  = 0;
  wc.lpszMenuName   = NULL;
  wc.lpszClassName  = lpszClassName;

  if (RegisterClass(&wc))
  {
    HWND hWnd = CreateWindowEx(WS_EX_TOPMOST,
                            lpszClassName,
                            lpszCaption,
                            WS_VISIBLE,
                            CW_USEDEFAULT,    // x
                            CW_USEDEFAULT,    // y 
                            CW_USEDEFAULT,
                            CW_USEDEFAULT,
                            NULL,
                            NULL,
                            hInstance,
                            0);


    if (hWnd)
    {

    #if defined(_WIN32_WCE)
      // hide all adornments if we are running Windows CE
      SHFullScreen(hWnd, SHFS_HIDESTARTICON | SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON);
      // hide the task bar
      HWND hWndTaskbar = ::FindWindow(TEXT("HHTaskbar"), NULL);
      ShowWindow(hWndTaskbar, SW_HIDE);
    #endif

      display = Display::Create(hWnd);
      if (display == 0)
        return 0;


      ShowWindow(hWnd, nCmdShow);
      UpdateWindow(hWnd);
      ShowCursor(false);

      while (msg.message != WM_QUIT)
      {
        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
        {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
        }
        else
        {
            if (quit)
                break;

			unsigned short int *dst = (unsigned short int *)display->GetBackBuffer()->GetPixels();

			memset(dst,0xFF,display->GetBackBuffer()->GetHeight()*display->GetBackBuffer()->GetWidth()*2);

			display->Swap();
        }
      }


      delete display;

    #if defined(_WIN32_WCE)
      // show the task bar
      hWndTaskbar = ::FindWindow(TEXT("HHTaskbar"), NULL);
      ShowWindow(hWndTaskbar, SW_SHOW);
      // restore all adornments if we are running Windows CE
      SHFullScreen(hWnd, SHFS_SHOWSTARTICON | SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON);
    #endif

      if (DestroyWindow(hWnd))
        UnregisterClass(lpszClassName, hInstance);

    }

  }
  
            
  return msg.wParam;
}
